<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.DateFormatter"
	import="java.util.Calendar"
	import="java.util.Locale"
	import="java.text.SimpleDateFormat"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.labenv");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="../css/reggie.css">
	<script language="JavaScript" src="../reggie.js" type="text/javascript" charset="UTF-8"></script>

<script language="JavaScript">

window.onload = function()
{
	// Create lab sensor menu from configuration data
	createSensorMenu();
};

function createSensorMenu()
{
	// Get lab sensor configurations dynamically from server data
	var frm = document.forms['labenv'];
	var labSensorConfigList = getLabSensorConfigList();
	if (labSensorConfigList != null)
	{
		// Construct lab sensor menu from JSON data
		var sensorSelect = document.getElementById('sensorSelectId');
		for (var i=0; i < labSensorConfigList.length; i++)
		{
			// Get URL and name for lab sensor number 'i'
			var labSensorConfig = labSensorConfigList[i];
			var sensorUrl = labSensorConfig['url'];
			var sensorName = labSensorConfig['name'];
			// Create and add new option element to select menu
			var optionEl = document.createElement('option');
			optionEl.setAttribute('value',sensorUrl);
			optionEl.innerHTML = sensorName;
			sensorSelect.appendChild(optionEl);
		}
	}
}

function getLabSensorConfigList()
{
	// Get lab sensor configurations JSON object with AJAX
	var frm = document.forms['labenv'];
	var request = Ajax.getXmlHttpRequest();
	var url = '../../labenv.jar/LabEnvironment.servlet?ID=<%=ID%>&cmd=GetLabSensorConfigList';
	request.open("GET", url, false); 
	request.send(null);
	
	//if (debug) Main.debug(request.responseText);
	//Main.debug(request.responseText);

	var response = JSON.parse(request.responseText);
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	
	// Get sensor configurations information from the AJAX response
	var labSensorConfigList = response.labSensorConfigList;

	return labSensorConfigList;
}

function goExport(preview)
{
	var frm = document.forms['labenv'];
	var url = '../../labenv.jar/LabEnvironment.servlet?ID=<%=ID%>&cmd=LabEnvironmentDatabaseQuery';
	if (frm.sensorSelect.value != null) url += '&sensorurl='+frm.sensorSelect.value;
	var sensorUrlText = frm.sensorSelect[frm.sensorSelect.selectedIndex].text;
	url += '&sensorname='+sensorUrlText;
	url += '&fdate='+frm.fromDate.value;
	url += '&ftime='+frm.fromTime.value;
	url += '&tdate='+frm.toDate.value;
	url += '&ttime='+frm.toTime.value;
	if (frm.displayIndexSelect.value != null) url += '&displayindex='+frm.displayIndexSelect.value;
	url += '&returntype=export';
	if (preview) 
	{
		var previewTitle = document.getElementById('previewTitle');
		var previewList = document.getElementById('previewList');
		
		Main.hide('previewWrapper');
		previewTitle.innerHTML = 'Working...';
		previewList.innerHTML = '';
		
		url += '&preview=1';
		var request = Ajax.getXmlHttpRequest();
		
		try
		{
			showLoadingAnimation('Working...');
			request.open("GET", url, false);	
			request.send(null);
		}
		finally
		{
			hideLoadingAnimation();
		}

		if (request.status != 200)
		{
			Main.openPopup('', 'ErrorWindow', 800, 600);
			Main.getWindow('ErrorWindow').document.write(request.responseText);
		}
		else
		{
			var allLines = request.responseText.split('\n');
			var numCases = allLines.length - 2; // First line is a header line
			var numSpecimen = 0;
			var numNoSpecimen = 0;
			
			var html = '<tr><th>'+allLines[0].replace(/\t/g, '</th><th>')+'</th></tr>';
			// Check second column for the 'Subtype' value
			var numNoConsent = 0;
			var numMissingConsent = 0;
			for (var i = 1 ; i <= numCases; i++)
			{
				var line = allLines[i];
				var cols = line.split(/\t/);
				var sampleSubtype = cols[1];
				if (sampleSubtype == 'Specimen')
				{
					numSpecimen++;
				}
				else if (sampleSubtype == 'NoSpecimen')
				{
					numNoSpecimen++;
				}
				var rowClass = '';
				html += '<tr class="'+rowClass+'"><td>'+cols.join('</td><td>')+'</td></tr>';
			}

			//var sensorUrlText = frm.sensorSelect[frm.sensorSelect.selectedIndex].text;
			previewTitle.innerHTML = 'Sensor - ' + sensorUrlText;
			previewList.innerHTML = '<table>'+html+'</table>';
			Main.show('previewWrapper');
		}
	}
	else
	{
		window.location = url;		
	}
	
}

function fromDateTimeOnChange()
{
	var frm = document.forms['labenv'];
	var todaysDate = new Date();
	fromDateIsValid = false;
	setInputStatus('fromDate', '', '');
	
	var fromDate = frm.fromDate.value;
	var fromTime = frm.fromTime.value;
	
	if (fromDate != '' || fromTime != '')
	{
		// Auto-fill the date if it's only given with 4(MMdd) or 6(yyMMdd) digits.
		fromDate = autoFillDate(fromDate);
		frm.fromDate.value = fromDate;

		fromTime = autoFillTime(fromTime);
		frm.fromTime.value = fromTime;
		
		if (!Dates.isDate(fromDate, 'yyyyMMdd'))
		{
			setInputStatus('fromDate', 'Not a valid date', 'invalid');
			return;
		}		
		
		if (!Dates.isDate(fromDate + ' ' + fromTime, 'yyyyMMdd HHmm'))
		{
			if (fromDate != '') setInputStatus('fromDate', 'Not a valid time (if time unknown, also leave date field blank)', 'invalid');
			return;
		}
		setInputStatus('fromDate', '', 'valid');
	}
	fromDateIsValid = true;
	toDateTimeOnChange();
}

function toDateTimeOnChange()
{
	var frm = document.forms['labenv'];
	var todaysDate = new Date();
	toDateIsValid = false;
	setInputStatus('toDate', '', '');
	
	var toDate = frm.toDate.value;
	var toTime = frm.toTime.value;
	
	if (toDate != '' || toTime != '')
	{
		// Auto-fill the date if it's only given with 4(MMdd) or 6(yyMMdd) digits.
		toDate = autoFillDate(toDate);
		frm.toDate.value = toDate;

		toTime = autoFillTime(toTime);
		frm.toTime.value = toTime;
		
		if (!Dates.isDate(toDate, 'yyyyMMdd'))
		{
			setInputStatus('toDate', 'Not a valid date', 'invalid');
			return;
		}		
		
		if (!Dates.isDate(toDate + ' ' + toTime, 'yyyyMMdd HHmm'))
		{
			if (toDate != '') setInputStatus('toDate', 'Not a valid time (if time unknown, also leave date field blank)', 'invalid');
			return;
		}
		setInputStatus('toDate', '', 'valid');
	}
	toDateIsValid = true;
}

</script>
<style>

.fullyear
{
	font-weight: bold;
}

#previewWrapper
{
	position: absolute;
	//top: 11em;
	top: 15em;
	bottom: 1em;
	left: 20px;
	width: 950px;
	overflow: visible;
}

#previewList
{
	position: absolute;
	top: 1.5em;
	bottom: 0px;
	width: 950px;
	overflow: auto;
	white-space: pre; 
	font-family: monospace;
	border: 1px dotted #A0A0A0;
	border-radius: 4px;
	background: #E8E8E8;
	padding: 0.25em;
}

#previewTitle
{
	font-weight: bold;
}

#previewList th
{
	border-bottom: 1px dotted #A0A0A0;
}

#previewList td, #previewList th
{
	text-align: left;
	padding-right: 2em;
	vertical-align: bottom;
}

.consent-warning
{
	color: #A00000;
	background-color: #F8F8E8;
}

.consent-warning td:last-child
{
	background-image: url('../images/warning_small.png');
	background-position: 95% 50%;
	background-repeat: no-repeat;
}

</style>
</base:head>
<base:body >

	<p:path><p:pathelement 
		title="LabEnv" href="<%="./labenvironmentdatabaseexport.jsp?ID="+ID%>" 
		/><p:pathelement title="Lab environment database export" 
		/></p:path>

	<div class="content">
	<form name="labenv" onsubmit="return false;">
	
	<!-- 1. Select lab sensor -->
	<table border="0" cellspacing="0" cellpadding="0" class="stepform">
	<tr>
		<td rowspan="3" class="stepno">1</td>
		<td class="steptitle">Select lab sensor(s) and time period</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table border="0" cellspacing="0" cellpadding="0" width="100%">
			<tr>
				<td class="prompt">Sensor</td>
				<td class="input">
					<select id="sensorSelectId" name="sensorSelect">
						<option value="all">All</option>
					</select>
				</td>
				<td class="status" id="sensorSelect.status"></td>
				<td class="help"><span id="time.message" class="message" style="display: none;"></span></td>
			</tr>			
			<tr id="fromDateTimeSection" valign="top">
				<td class="prompt">From</td>
				<td class="input">Date <input type="text" name="fromDate" value="" size="12" maxlength="10" 
						onkeypress="focusOnEnter(event, 'fromTime')" onblur="fromDateTimeOnChange()">
					Time <input type="text" name="fromTime" value="" size="6" maxlength="4" 
						onkeypress="focusOnEnter(event, 'fromDate')" onblur="fromDateTimeOnChange()"></td>
				<td class="status" id="fromDateTime.status"></td>
				<td class="help"><span id="fromDateTime.message" class="message" style="display: none;"></span>Start date+time (YYYYMMDD, HHMM) Blank fields give data from start</td>
			</tr>
			<tr id="toDateTimeSection" valign="top">
				<td class="prompt">To</td>
				<td class="input">Date <input type="text" name="toDate" value="" size="12" maxlength="10"
						onkeypress="focusOnEnter(event, 'toTime')" onblur="toDateTimeOnChange()">
					Time <input type="text" name="toTime" value="" size="6" maxlength="4"
						onkeypress="focusOnEnter(event, 'toTime')" onblur="toDateTimeOnChange()"></td>
				<td class="status" id="toDateTime.status"></td>
				<td class="help"><span id="toDateTime.message" class="message" style="display: none;"></span>End date+time (YYYYMMDD, HHMM) Blank fields give data to end</td>
			</tr>
			<tr id="displayIndexSection" valign="top">
				<td class="prompt">Display index values</td>
				<td class="input">
					<select id="displayIndexSelectId" name="displayIndexSelect">
						<option value="true">Yes</option>
						<option value="false" selected="yes">No</option>
					</select>
				</td>
				<td class="status" id="displayIndex.status"></td>
				<td class="help"><span id="displayIndex.message" class="message" style="display: none;"></span>Select if database indices should be displayed</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>

	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>

	<div id="done" class="success" style="display: none; width: 950px; margin-left: 20px; margin-top: 20px;"></div>

	<table style="margin-left: 20px; margin-top: 10px;" class="navigation">
	<tr>
<!--
		<td><base:button id="gopreview" title="Preview" image="<%=home+"/images/export.png"%>" onclick="goExport(true)"/></td>
		<td><base:button id="goexport" title="Download" image="<%=home+"/images/download.png"%>" onclick="goExport(false)"/></td>
-->
		<td><base:button id="gopreview" title="Preview" image="<%="export.png"%>" onclick="goExport(true)"/></td>
		<td><base:button id="goexport" title="Download" image="<%="download.png"%>" onclick="goExport(false)"/></td>
	</tr>
	</table>
	</form>
	
	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="../images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	
	<div id="previewWrapper" style="display: none;">
		<div>
			<span id="previewTitle">Preview</span>
			<span id="previewWarning"></span>
		</div>
		<div id="previewList"></div>
	</div>
	
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>